#
# spec file for package cimple
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           cimple

Version:        2.0.24
Release:        2.2
Summary:        CIMPLE is an embeddable CIM provider engine
License:        MIT
Group:          System/Management
Url:            http://cimple.org
Source0:        %{name}-%{version}.tar.bz2
Patch1:         %{name}-%{version}-ow-adapter.dif
Patch2:         %{name}-%{version}-gcc.patch
Patch3:         aarch64-support.patch
Patch4:         ppc64le-support.patch
# enable installation of cimlisten tool, kkaempf@suse.de
Patch5:         install-cimlisten.patch
# gcc6 fixes
Patch6:         cimple-2.0.24-gcc6.patch
BuildRequires:  gcc-c++
BuildRequires:  gdb
BuildRequires:  konkretcmpi
BuildRequires:  sblim-cmpi-devel
BuildRequires:  tog-pegasus-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
CIMPLE is an embeddable CIM provider engine. It is used to (1) build
providers that will work with a variety of CIM servers and (2) provide
a foundation for implementing CIM-based standards such as WBEM, SMASH,
WSDM, and WS Management.

%package devel
Summary:        Header files for CIMPLE : an embeddable CIM provider engine
Group:          System/Management
Requires:       %{name} = %{version}
Requires:       gcc-c++

%description devel
Header files for CIMPLE : an embeddable CIM provider engine. It is used
to (1) build providers that will work with a variety of CIM servers and
(2) provide a foundation for implementing CIM-based standards such as
WBEM, SMASH, WSDM, and WS Management.

%package cmpi-adapter
Summary:        CMPI Adapter for CIMPLE providers
Group:          System/Management
Requires:       %{name} = %{version}

%description cmpi-adapter
The CMPI Adapter for CIMPLE is a bridge between the universal CMPI
provider interface and CIMPLE providers.  Using this adapter,
CIMPLE providers can run under any CIMOM.

%package pegasus-adapter
Summary:        Pegasus Adapter for CIMPLE providers
Group:          System/Management
Requires:       %{name} = %{version}

%description pegasus-adapter
The Pegasus Adapter for CIMPLE is a bridge between the native Pegasus
C++ provider interface and CIMPLE providers.  Using this adapter,
CIMPLE providers can run under Pegasus without using the CMPI layer.

%package -n brevity
Summary:        Pegasus Client SDK
Group:          System/Management
Requires:       %{name} = %{version}
Requires:       %{name}-devel = %{version}
Requires:       %{name}-pegasus-adapter = %{version}
Requires:       tog-pegasus-devel

%description -n brevity
Brevity is a software development kit for Pegasus (tog-pegasus) clients

%if 0
%package openwbem-adapter
Summary:        OpenWBEM Adapter for CIMPLE providers
Group:          System/Management
Requires:       %{name} = %{version}

%description openwbem-adapter
The OpenWBEM Adapter for CIMPLE is a bridge between the native OpenWBEM
C++ provider interface and CIMPLE providers.  Using this adapter,
CIMPLE providers can run under OpenWBEM without using the CMPI layer.

%package openwbem-devel
Summary:        Header file for CIMPLE providers using the OpenWBEM Adapter
Group:          System/Management
Requires:       %{name} = %{version}
Requires:       %{name}-devel = %{version}
Requires:       %{name}-openwbem-adapter = %{version}
Requires:       openwbem-devel

%description openwbem-devel
Header file for building CIMPLE providers that will use the
cimple-openwbem-adapter. This header is only needed by the
module.cpp file (part of a CIMPLE provider).

%endif

%prep
%setup -q
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build
export CIMPLE_DEBUG=1
./configure \
        --bindir=%{_bindir}  \
        --libdir=%{_libdir}  \
        --prefix=%{_prefix}  \
        --with-cmpi=/usr/include/cmpi \
        --with-pegasus=/usr
#        --with-openwbem=/usr

make  FLAGS="%{optflags} -fno-strict-aliasing -fPIC" %{?_smp_mflags}

%install
rm -rf %{buildroot}
mkdir %{buildroot}
%if 0%{?suse_version} > 1110
%make_install
%else
DESTDIR=%{buildroot} make install
%endif
rm -r %{buildroot}/%{_prefix}/share

%check
#make check

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)
%{_bindir}/*
%{_libdir}/libcimple.so

%files devel
%defattr(-, root, root)
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/[a-z]*
%{_includedir}/%{name}/[A-N]*
# skip OpenWBEM_Adapter.h
%{_includedir}/%{name}/Ops.h
%{_includedir}/%{name}/[P-Z]*

%if 0
%files openwbem-adapter
%defattr(-, root, root)
%{_libdir}/libcimpleowadap.so

%files openwbem-devel
%defattr(-, root, root)
%{_includedir}/%{name}/OpenWBEM_Adapter.h
%endif

%files cmpi-adapter
%defattr(-, root, root)
%{_libdir}/libcimplecmpiadap.so

%files pegasus-adapter
%defattr(-, root, root)
%{_libdir}/libcimplepegadap.so

%files -n brevity
%defattr(-, root, root)
%dir %{_prefix}/include/brevity
%{_prefix}/include/brevity/*
%{_libdir}/libbrevity.so

%changelog
* Sat Jun 18 2016 kkaempf@suse.com
- add cimple-2.0.24-gcc6.patch for GCC6.
* Tue Jun  2 2015 kkaempf@suse.com
- add %%check section to spec file
* Thu Mar 19 2015 kkaempf@suse.com
- merge with cimple-pegasus, build tog-pegasus specifics now
  add install-cimlisten.patch
- split off brevity, pegasus-adapter, and cmpi-adapter
  as sub-packages
* Tue Jul 29 2014 dvaleev@suse.com
- Fix build on PowerPC little endian
- added patches:
  * ppc64le-support.patch
* Tue Apr 16 2013 schwab@suse.de
- aarch64-support: Add support for aarch64
  * aarch64-support.patch
* Fri Nov 16 2012 kkaempf@suse.com
- Fix build for older SUSE distros
* Mon Nov 12 2012 cfarrell@suse.com
- license update: MIT
  Use SPDX syntax for License line in spec file
  (http://www.spdx.org/licenses)
* Fri Nov  9 2012 kkaempf@suse.com
- Clean up behind spec-cleaner, %%make_install is SUSE-specific
* Fri Nov  9 2012 aj@suse.de
- Run through spec-cleaner.
* Mon Nov  5 2012 kkaempf@suse.com
- Update to 2.0.24
  This is a minor release issued correct an error found in the
  association operation with the PegasusAdapter and an error introduced
  in 2.0.22 in genmod. The genmod error would be evidenced by a users in
  inability to register providers with regmod to OpenPegasus. It is
  recommended that vesion 2.0.22 users upgrade to this verison of
  SimpleWbem. Note that version 2.0.22 introduced a new configuration
  parameter that allows users to control use of the macros that generate
  log entries
* Mon Nov  5 2012 kkaempf@suse.com
- Update to 2.0.22
  This is a minor release issued to extend error handling of the log
  file and provide diagnostic information if the provider has problems
  configuring and creating logs.
* Mon Nov  5 2012 kkaempf@suse.com
- Update to 2.0.17
  This is a minor release primarily to fix some issues with adapters and
  implement extensions to the logging functions. This minor version
  added functionality to allow better control of logging and to
  implement APIs so that the provider can dynamically control some
  configuration capabilities (class CimpleConfig). This logging
  extension was at user request since the CIMPLE users want to utilize
  the logging capability in production as well as development. NOTE:
  Please consider CimpleConfig experimental for this release since this
  the first time it will be used generally. We will freeze in the next
  release. Notable changes:
  * Added capability to limit size of log files and backup logs files
  * Added conditional trace for adapters. Implemented for Pegasus adapter
  * Added compile config parameter to control adapter trace
    (--enable-adapter-trace)
  * Added compile config parameter to disable logging (--disable_log_macros)
  * Added runtime config parameter to set max log file
    size(MAX_LOG_FILE_SIZE=(integer)
  * Added runtime config parameter to set max number of backup log
    files(MAX_LOG_BACKUP_FILES=(integer)
  * Added runtime config parameter to disable all
    logging(ENABLE_LOGGING=false)
  * Fixed issues with Pegasus adapter and possible excess memory use
  * Extended unit and test provider tests
  * Added general option to all gen... utilities (-F) to get classlist
    from file
  * Minor performance enhancements
  * Continued improvement of documentation with changes to header files,
    additional readme files and more examples in test providers(/li>
* Wed May  4 2011 kkaempf@novell.com
- Cimple version 2.0.16
